import { CommandUtil } from "../interfaces/command-util";
import { IPostal } from "../interfaces/postal";
import { ForceErrorImpl } from "./force-error-impl";
export declare class CommandUtilImpl extends ForceErrorImpl implements CommandUtil {
    private postal;
    private _console;
    private exitHandler;
    private registerProcessManagementEvents;
    constructor(postal: IPostal);
    stderrWrite(msg: string): void;
    stdoutWrite(msg: string): void;
    private stderrLog;
    private stdoutLog;
    returnErrorStringOrMessage(err: Error, message: string): string;
    error(msg: string): void;
    log(msg: string): void;
    logErrors(errs: Error[], writeErrorToConsole?: boolean): string[];
    logError(err: Error, writeErrorToConsole?: boolean): string;
    processExitIfError(err: Error): void;
    processExitWithError(err: Error, nonErrorMessage?: string): void;
    processExit(exitCode?: number, msg?: string): void;
    callbackIfError(cb: (err: Error, anything: any, anything2?: any) => void, err?: Error, result?: any): boolean;
    logAndCallback(msg: string, cb: (err: Error, anything: any, anything2?: any) => void, err?: Error, result?: any): boolean;
    getConfigFilePath(filename: string, extension?: string): string;
}
