"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const inversify_1 = require("inversify");
const inversify_config_1 = require("../inversify.config");
const _ = require("lodash");
const status = require('node-status');
let ProgressBarImpl = class ProgressBarImpl {
    constructor(postal) {
        this.postal = postal;
        this.tasks = [];
        this.started = false;
        this.patternBase = '{uptime.green} {spinner.cyan}';
        this.pattern = '';
        this.postal.subscribe({
            channel: 'ProgressBar',
            topic: 'Stop',
            callback: () => {
                if (this.started) {
                    status.stop();
                }
            }
        });
    }
    showProgressForTask(id, msg, current, total) {
        this.postal.publish({
            channel: 'CommandUtil',
            topic: 'ProgressBarStarted',
            data: {
                console: status.console()
            }
        });
        let task = _.find(this.tasks, { id });
        if (!task) {
            if (current >= total) {
                return;
            }
            task = inversify_config_1.default.get('ProgressTask');
            this.tasks.push(task);
            task.id = id;
            task.msg = msg;
            task.statusItem = status.addItem(id, {
                max: total,
                count: current
            });
        }
        else {
            if (current >= total) {
                status.removeItem(task.id);
                _.remove(this.tasks, t => {
                    return task.id == t.id;
                });
            }
            else {
                task.statusItem.count = current;
                task.statusItem.max = total;
            }
        }
        this.render();
    }
    render() {
        let pattern = this.patternBase;
        this.tasks.forEach(task => {
            pattern += ` | ${task.msg} {${task.id}.green.bar}`;
        });
        if (this.started) {
            if (this.pattern == pattern) {
                return;
            }
            status.setPattern(this.pattern = pattern);
        }
        else {
            this.started = true;
            status.start({
                pattern
            });
        }
    }
};
ProgressBarImpl = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject('IPostal')),
    __metadata("design:paramtypes", [Object])
], ProgressBarImpl);
exports.ProgressBarImpl = ProgressBarImpl;
//# sourceMappingURL=progress-bar-impl.js.map