/// <reference types="node" />
import { Url } from 'url';
import { ForceErrorImpl, CommandUtil, SafeJson, RemoteCatalogGetter, RemoteCatalogResource } from '..';
export declare class RemoteCatalogGetterImpl extends ForceErrorImpl implements RemoteCatalogGetter {
    private commandUtil;
    private safeJson;
    constructor(commandUtil: CommandUtil, safeJson: SafeJson);
    getCatalogFromUrl(url: Url | string, cb: (err: any, remoteCatalog: any) => void): void;
    getRemoteResource(url: Url | string, parentCatalogEntryName: string, cb: (err: Error, remoteCatalogResource?: RemoteCatalogResource) => void): void;
    resolveJsonObjectFromUrl(url: Url | string, cb: (err: Error, jsonObject: any, absoluteUrl: string) => void): void;
    resolveTextResourceFromUrl(url: Url | string, cb: (err: Error, text?: string, absoluteUrl?: string) => void): void;
    getParsedUrl(url: Url | string, cb: (err: Error, parsedUrl?: Url) => void): void;
}
