"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var progress_bar_impl_1 = require("./implementations/progress-bar-impl");
var command_line_impl_1 = require("./implementations/command-line-impl");
var command_util_impl_1 = require("./implementations/command-util-impl");
var nested_yargs_wrapper_impl_1 = require("./implementations/nested-yargs-wrapper-impl");
var spawn_impl_1 = require("./implementations/spawn-impl");
var child_process_spawn_impl_1 = require("./implementations/child-process-spawn-impl");
var command_impl_1 = require("./implementations/command-impl");
var positive_impl_1 = require("./implementations/positive-impl");
var progress_task_impl_1 = require("./implementations/progress-task-impl");
var postal_impl_1 = require("./implementations/postal-impl");
var crypton_impl_1 = require("./implementations/crypton-impl");
var remote_catalog_impl_1 = require("./implementations/remote-catalog-impl");
var safe_json_impl_1 = require("./implementations/safe-json-impl");
var kernel = new inversify_1.Container();
kernel.bind('CommandUtil').to(command_util_impl_1.CommandUtilImpl).inSingletonScope();
kernel.bind('ProgressBar').to(progress_bar_impl_1.ProgressBarImpl).inSingletonScope();
kernel.bind('Crypton').to(crypton_impl_1.CryptonImpl).inSingletonScope();
kernel.bind('SafeJson').to(safe_json_impl_1.SafeJsonImpl).inSingletonScope();
kernel.bind('IPostal').to(postal_impl_1.PostalImpl).inSingletonScope();
kernel.bind('ChildProcessSpawn').to(child_process_spawn_impl_1.ChildProcessSpawnImpl).inSingletonScope();
kernel.bind('RemoteCatalogGetter').to(remote_catalog_impl_1.RemoteCatalogGetterImpl).inSingletonScope();
kernel.bind('ProgressTask').to(progress_task_impl_1.ProgressTaskImpl);
kernel.bind('CommandLine').to(command_line_impl_1.CommandLineImpl);
kernel.bind('NestedYargs').to(nested_yargs_wrapper_impl_1.NestedYargsImpl);
kernel.bind('CommandImpl').to(command_impl_1.CommandImpl);
kernel.bind('Spawn').to(spawn_impl_1.SpawnImpl);
kernel.bind('Positive').to(positive_impl_1.PositiveImpl);
exports.default = kernel;
